<?

/*

Nanoweb CGI support module
==========================

Copyright (C) 2002 Vincent Negrier aka. sIX <six@aegis-corp.org>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

class mod_cgi {

	function mod_cgi() {

		$this->modtype="parser_CGI";
		$this->modname="CGI support";
	
	}

	function parser_open($dummy_content, $args, $filename, &$rq_err, &$cgi_headers, &$add_ctype) {

		global $conf;

		$cgiexec=$args;
		$nsv=nw_server_vars();
		if ($conf["global"]["cgifilterpathinfo"][0]) unset($nsv["PATH_INFO"]);
		foreach($nsv as $key=>$var) putenv($key."=".$var);
		putenv("GATEWAY_INTERFACE=CGI/1.1");

		if ($rq_hdrs=$GLOBALS["htreq_headers"]) foreach($rq_hdrs as $key=>$val) putenv("HTTP_".str_replace("-", "_", $key)."=".$val);
		
		if ($GLOBALS["http_action"]=="POST" && $GLOBALS["htreq_content"]) {
		
			putenv("CONTENT_TYPE=".$rq_hdrs["CONTENT-TYPE"]);
			putenv("CONTENT_LENGTH=".$rq_hdrs["CONTENT-LENGTH"]);

			$tmp_filename=$conf["global"]["tempdirectory"][0]."/nweb_cgi_post.".$GLOBALS["mypid"];

			$ftmp=fopen($tmp_filename, "w");
			fwrite($ftmp, $GLOBALS["htreq_content"]);
			fclose($ftmp);
			$this->tmpfile=$tmp_filename;

			$cgipiped=$cgiexec."<".$tmp_filename;
			
			if (!$this->p=@popen($cgipiped, "r")) {

				$this->peof=true;
				$rq_err=500;
				techo("WARN: cannot open pipe to '".$cgiexec."'");

			} else $this->peof=false;
		
		} else {

			if (!$this->p=@popen($cgiexec, "r")) {
				
				$this->peof=true;
				$rq_err=500;
				techo("WARN: cannot open pipe to '".$cgiexec."'");

			} else $this->peof=false;

		}

		if ($this->p) while ($lastread!="\r\n" && $lastread!="\n") {
			
			if (!$lastread=fgets($this->p, 1024)) break;
			$content.=$lastread;
		}

		if ( (($p1=strpos($content, "\r\n\r\n"))!==false) || (($p1=strpos($content, "\n\n"))!==false) ) {
		
			if ((strpos($content, "\r\n\r\n"))!==false) $pn=4; else $pn=2;
			$headers=explode("\n", trim(substr($content, 0, $p1)));
			$content=substr($content, $p1+$pn);

		}

		$GLOBALS["out_encoded"]=false;
		$GLOBALS["http_resp"]="";
		
		$hcount=count($headers)-1;

		for($a=0;$a<=$hcount;$a++) if ($s=trim($headers[$a])) {

			if (substr($s, 0, 5)=="HTTP/") {

				$hd_key="";
				$tmp=explode(" ", $s);
				$rq_err=(int)$tmp[1];
			
			} else {
			
				$hd_key=substr($s, 0, strpos($s, ":"));
				$hd_val=trim(substr($s,strpos($s, ":")+1));

			}

			switch(strtoupper($hd_key)) {

				case "CONTENT-TYPE": $add_ctype=$hd_val;
				break;

				case "LOCATION": $rq_err=302;
				break;

				case "SET-COOKIE": $cgi_headers["cookies"][]=$hd_val;
				break;

				case "CONTENT-ENCODING": $GLOBALS["out_encoded"]=true;
				break;

				case "STATUS":
				$GLOBALS["http_resp"]=$hd_val;
				break;

			}
			
			if (($hd_key) && (strtoupper($hd_key)!="SET-COOKIE")) $cgi_headers[$hd_key]=$hd_val;

		}

	}

	function parser_get_output() {

		$tmp=fread($this->p, 1024);
		if (!$tmp) $this->peof=true;
		return($tmp);
	
	}
	
	function parser_eof() {

		return($this->peof);
	
	}
	
	function parser_close() {

		if ($this->tmpfile && is_file($this->tmpfile)) unlink($this->tmpfile);
		@pclose($this->p);

	}

}

?>
