<?

/*

Nanoweb Status Report Module
============================

Copyright (C) 2002 Vincent Negrier aka. sIX <six@aegis-corp.org>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

class mod_status {

	function mod_status() {

		global $conf;
		
		$this->modtype="url";
		$this->modname="Server status report";
		$this->urls=array("/server-status");

	}

	function url(&$rq_err, &$out_contenttype, &$out_add_headers) {

		global $stats_start, $stats_cnx, $stats_hits, $stats_modlist, $remote_ip, $remote_host, $modules, $conf, $logger_pids, $server_pids, $mypid, $query_string, $server_pids_remote, $htreq_headers;
		
		if ($allow=$conf["global"]["statusallowhost"]) for ($a=0;$a<count($allow);$a++) if ((strpos($remote_host, $allow[$a])!==false) || (strpos($remote_ip, $allow[$a])!==false)) $host_allowed=true;
		
		if ($host_allowed) {
		
			$rq_err=200;
			
			if ($query_string=="who") {

				$out_contenttype="text/plain";
				
				$c=count($server_pids);
				$s=($c?$c:"no")." active servers";

				if (count($server_pids)) {
				
					$s.="\n\n";

					reset($server_pids);
					while (list($pid, $status)=each($server_pids)) {

						$s.=str_pad($pid, 5, " ", STR_PAD_LEFT)." - ".$server_pids_remote[$pid]."\n     -> ".$server_pids[$pid]."\n";
					
					}
			
				}
			
			} else {
			
				$out_contenttype="text/html";

				$startd=gmdate("D, d M Y H:i:s T", $stats_start);
				$uptime=(((int)date("U"))-$stats_start);
				
				$up_d=(int)($uptime/86400);
				$up_h=((int)($uptime/3600))%24;
				$up_m=((int)($uptime/60))%60;
				$up_s=$uptime%60;

				$upstr=($up_d?($up_d."d, "):"").(($up_h||$up_d)?($up_h."h, "):"").(($up_m||$up_h||$up_d)?($up_m."m, "):"").$up_s."s";
				
				$s="<center>Nanoweb server status module</center><br>";
				$s.="<br>";
				$s.="Server  : <b>".SERVER_STRING."</b> (PHP/".phpversion().")<br>";
				$s.="Started : <b>".$startd."</b><br>";
				$s.="Uptime  : <b>".$upstr."</b><br>";
				$s.="<br>";

				$s.="Loaded modules :";
				for ($a=0;$a<count($stats_modlist);$a++) $s.=" ".$stats_modlist[$a];
				$s.="<br><br>";

				$s.="Active servers  : <b>".(count($server_pids)+1)."</b> (";

				unset($tmp);
				while (list($pid, $true)=each($server_pids)) $tmp[]=$pid;
				$tmp[]=$mypid;
				$s.=implode(" ", $tmp);
					
				$s.=")<br>";
				
				$s.="Logging done by : <b>";
				
				if ($conf["global"]["loggerprocess"][0]) {

					$s.="loggers</b><br>";
					$s.="Active loggers  : <b>".count($logger_pids). "</b> (";

					if ($c=count($logger_pids)) {
						
						unset($tmp);
						while (list($pid, $lgid)=each($logger_pids)) $tmp[]="#".$lgid."=".$pid;
						$s.=implode(" ", $tmp);
					
					}

					$s.=")<br>";
				
				} else {

					$s.="servers</b><br>";
				
				}
				
				$s.="<br>";
				$s.="Total handled connections : <b>".$stats_cnx."</b><br>";
				$s.="Total hits served         : <b>".($stats_hits+1)."</b><br>";
				$s.="Average hits              : <b>".sprintf("%.2f", (($stats_hits/$uptime)*60))."</b>/min (<b>".sprintf("%.2f", ($stats_hits/$uptime))."</b>/s)<br>";
				$s.="<br>";
				$s.="<center>The server is working properly</center>";

				if (strpos($htreq_headers["USER-AGENT"], "Lynx")===0) {

					$out_contenttype="text/plain";
					$s=strip_tags(str_replace("<br>", "\n", $s));
				
				}

			}
		
		} else {

			// Return 403 Forbidden if hit is not coming from localhost
			
			$pri_err=403;
			$s="no access";

		}

		return($s);
	
	}

}

?>